/*-
 * SPDX-License-Identifier: BSD-2-Clause
 *
 * Copyright 2018 Emmanuel Vadot <manu@FreeBSD.org>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _RK_CLK_ARMCLK_H_
#define _RK_CLK_ARMCLK_H_

#include <dev/clk/clk.h>

struct rk_clk_armclk_rates {
	uint64_t	freq;
	uint32_t	div;
};

struct rk_clk_armclk_def {
	struct clknode_init_def	clkdef;

	uint32_t	muxdiv_offset;

	uint32_t	mux_shift;
	uint32_t	mux_width;

	uint32_t	div_shift;
	uint32_t	div_width;

	uint32_t	flags;

	uint32_t	main_parent;
	uint32_t	alt_parent;

	struct rk_clk_armclk_rates	*rates;
	int				nrates;
};

int rk_clk_armclk_register(struct clkdom *clkdom,
    struct rk_clk_armclk_def *clkdef);

#endif /* _RK_CLK_ARMCLK_H_ */
