/*-
 * SPDX-License-Identifier: BSD-2-Clause
 *
 * Copyright (c) 2021 The FreeBSD Foundation
 *
 * This software was developed by Konstantin Belousov <kib@FreeBSD.org>
 * under sponsorship from the FreeBSD Foundation.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <sys/cdefs.h>

#define	VDSO_BLOB_START(S)	__CONCAT(_binary_, __CONCAT(S, _start))
#define	VDSO_BLOB_END(S)	__CONCAT(_binary_, __CONCAT(S, _end))
#define	VDSO_BLOB_SIZE(S)	__CONCAT(_binary_, __CONCAT(S, _size))

	.section .rodata, "a", %progbits
	.globl	VDSO_BLOB_START(VDSO_NAME)
	.type	VDSO_BLOB_START(VDSO_NAME), %object
	.size	VDSO_BLOB_START(VDSO_NAME), 0
VDSO_BLOB_START(VDSO_NAME):
	.incbin	VDSO_FILE
	.globl	VDSO_BLOB_END(VDSO_NAME)
	.type	VDSO_BLOB_END(VDSO_NAME), %object
	.size	VDSO_BLOB_END(VDSO_NAME), 0
VDSO_BLOB_END(VDSO_NAME):
	.globl	VDSO_BLOB_SIZE(VDSO_NAME)
	.set	VDSO_BLOB_SIZE(VDSO_NAME), . - VDSO_BLOB_START(VDSO_NAME)
